---
title: 'CSS: Cascading Style Sheets'
slug: Web/CSS
tags:
  - CSS
  - Cascading Style Sheets
  - Design
  - Guide
  - Landing
  - Layout
  - Reference
  - Style Sheets
  - Styles
  - Stylesheets
  - 'l10n:priority'
---
<div>{{CSSRef}}</div>

<p class="summary"><span class="seoSummary"><strong>Cascading Style Sheets</strong> (<strong>CSS</strong>) is a <a href="/en-US/docs/DOM/stylesheet">stylesheet</a> language used to describe the presentation of a document written in <a href="/en-US/docs/Web/HTML" title="HyperText Markup Language">HTML</a></span> or <a href="/en-US/docs/XML_introduction">XML</a> (including XML dialects such as <a href="/en-US/docs/Web/SVG">SVG</a>, <a href="/en-US/docs/Web/MathML">MathML</a> or {{Glossary("XHTML")}}). CSS describes how elements should be rendered on screen, on paper, in speech, or on other media.</p>

<p>CSS is among the core languages of the <strong>open web</strong> and is standardized across Web browsers according to <a class="external" href="http://w3.org/Style/CSS/#specs">W3C specifications</a>. Previously, development of various parts of CSS specification was done synchronously, which allowed versioning of the latest recommendations. You might have heard about CSS1, CSS2.1, CSS3. However, CSS4 has never become an official version.</p>

<p>From CSS3, the scope of the specification increased significantly and the progress on different CSS modules started to differ so much, that it became more effective to <a href="https://www.w3.org/Style/CSS/current-work">develop and release recommendations separately per module</a>. Instead of versioning the CSS specification, W3C now periodically takes a snapshot of <a href="https://www.w3.org/TR/css/">the latest stable state of the CSS specification</a>.</p>

<h2 id="Key_resources">Key resources</h2>

<dl>
 <dt><span>CSS Introduction</span></dt>
 <dd>If you're new to web development, be sure to read our <a href="/en-US/docs/Learn/Getting_started_with_the_web/CSS_basics">CSS basics</a> article to learn what CSS is and how to use it.</dd>
 <dt><span>CSS Tutorials</span></dt>
 <dd>Our <a href="/en-US/docs/Learn/CSS">CSS learning area</a> contains a wealth of tutorials to take you from beginner level to proficiency, covering all the fundamentals.</dd>
 <dt><span>CSS Reference</span></dt>
 <dd>Our <a href="/en-US/docs/Web/CSS/Reference">exhaustive CSS reference</a> for seasoned Web developers describes every property and concept of CSS.</dd>
</dl>

<div class="in-page-callout webdev">
<h3 id="Looking_to_become_a_front-end_web_developer">Looking to become a front-end web developer?</h3>

<p>We have put together a course that includes all the essential information you need to work towards your goal.</p>

<p><a class="cta primary" href="/docs/Learn/Front-end_web_developer">Get started</a></p>
</div>

<div class="row topicpage-table">
<div class="section">
<h2 class="Documentation" id="Tutorials">Tutorials</h2>

<p>Our <a href="/en-US/docs/Learn/CSS">CSS Learning Area</a> features multiple modules that teach CSS from the ground up — no previous knowledge required.</p>

<dl>
 <dt><a href="/en-US/docs/Learn/CSS/First_steps">CSS first steps</a></dt>
 <dd>CSS (Cascading Style Sheets) is used to style and layout web pages — for example, to alter the font, color, size, and spacing of your content, split it into multiple columns, or add animations and other decorative features. This module provides a gentle beginning to your path towards CSS mastery with the basics of how it works, what the syntax looks like, and how you can start using it to add styling to HTML.</dd>
 <dt><a href="/en-US/docs/Learn/CSS/Building_blocks">CSS building blocks</a></dt>
 <dd>
 <p class="summary">This module carries on where <a href="/en-US/docs/Learn/CSS/First_steps">CSS first steps</a> left off — now you've gained familiarity with the language and its syntax, and got some basic experience with using it, it's time to dive a bit deeper. This module looks at the cascade and inheritance, all the selector types we have available, units, sizing, styling backgrounds and borders, debugging, and lots more.</p>

 <p class="summary">The aim here is to provide you with a toolkit for writing competent CSS and help you understand all the essential theory, before moving on to more specific disciplines like <a href="/en-US/docs/Learn/CSS/Styling_text">text styling</a> and <a href="/en-US/docs/Learn/CSS/CSS_layout">CSS layout</a>.</p>
 </dd>
 <dt><a href="/en-US/docs/Learn/CSS/Styling_text">Styling text</a></dt>
 <dd>With the basics of the CSS language covered, the next CSS topic for you to concentrate on is styling text — one of the most common things you'll do with CSS. Here we look at text styling fundamentals, including setting font, boldness, italics, line and letter spacing, drop shadows, and other text features. We round off the module by looking at applying custom fonts to your page, and styling lists and links.</dd>
 <dt><a href="/en-US/docs/Learn/CSS/CSS_layout">CSS layout</a></dt>
 <dd>At this point we've already looked at CSS fundamentals, how to style text, and how to style and manipulate the boxes that your content sits inside. Now it's time to look at how to place your boxes in the right place in relation to the viewport, and to each other. We have covered the necessary prerequisites so we can now dive deep into CSS layout, looking at different display settings, modern layout tools like flexbox, CSS grid, and positioning, and some of the legacy techniques you might still want to know about.</dd>
 <dt><a href="/en-US/docs/Learn/CSS/Howto">Use CSS to solve common problems</a></dt>
 <dd>This module provides links to sections of content explaining how to use CSS to solve common problems when creating a web page.</dd>
</dl>
</div>

<div class="section">
<h2 class="Tools" id="Reference">Reference</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/Reference">CSS reference</a>: This exhaustive reference for seasoned Web developers describes every property and concept of CSS.</li>
 <li>CSS key concepts:
  <ul>
   <li>The <a href="/en-US/docs/Web/CSS/Syntax">syntax and forms of the language</a></li>
   <li><a href="/en-US/docs/Web/CSS/Specificity">Specificity</a>, <a href="/en-US/docs/Web/CSS/Inheritance">inheritance</a>, and <a href="/en-US/docs/Web/CSS/Cascade">the Cascade</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Values_and_Units">CSS units and values</a> and <a href="/en-US/docs/Web/CSS/CSS_Functions">functional notations</a></li>
   <li><a href="/en-US/docs/Web/CSS/box_model">Box model</a> and <a href="/en-US/docs/Web/CSS/margin_collapsing">margin collapse</a></li>
   <li>The <a href="/en-US/docs/Web/CSS/All_About_The_Containing_Block">containing block</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/The_stacking_context" title="The stacking context">Stacking</a> and <a href="/en-US/docs/Web/CSS/block_formatting_context" title="block formatting context">block-formatting</a> contexts</li>
   <li><a href="/en-US/docs/Web/CSS/initial_value">Initial</a>, <a href="/en-US/docs/Web/CSS/computed_value">computed</a>, <a href="/en-US/docs/Web/CSS/used_value">used</a>, and <a href="/en-US/docs/Web/CSS/actual_value">actual</a> values</li>
   <li><a href="/en-US/docs/Web/CSS/Shorthand_properties">CSS shorthand properties</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout">CSS Flexible Box Layout</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout">CSS Grid Layout</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Selectors">CSS selectors</a></li>
   <li><a href="/en-US/docs/Web/CSS/Media_Queries">Media queries</a></li>
   <li><a href="/en-US/docs/Web/CSS/animation">Animation</a></li>
  </ul>
 </li>
</ul>

<h2 class="Tools" id="Cookbook">Cookbook</h2>

<p>The <a href="/en-US/docs/Web/CSS/Layout_cookbook">CSS layout cookbook</a> aims to bring together recipes for common layout patterns, things you might need to implement in your sites. In addition to providing code you can use as a starting point in your projects, these recipes highlight the different ways layout specifications can be used, and the choices you can make as a developer.</p>

<h2 class="Tools" id="Tools_for_CSS_development">Tools for CSS development</h2>

<ul>
 <li>You can use the <a class="external" href="https://jigsaw.w3.org/css-validator/">W3C CSS Validation Service</a> to check if your CSS is valid. This is an invaluable debugging tool.</li>
 <li><a href="/en-US/docs/Tools">Firefox Developer Tools</a> lets you view and edit a page's live CSS via the <a href="/en-US/docs/Tools/Page_Inspector">Inspector</a> and <a href="/en-US/docs/Tools/Style_Editor">Style Editor</a> tools.</li>
 <li>The <a class="link-https" href="https://addons.mozilla.org/en-US/firefox/addon/web-developer/">Web Developer extension</a> for Firefox lets you track and edit live CSS on watched sites.</li>
 <li>The Web community has created various other <a href="/en-US/docs/Web/CSS/Tools">miscellaneous CSS tools</a> for you to use.</li>
</ul>

<h2 id="Meta_bugs">Meta bugs</h2>

<ul>
 <li>Firefox: {{bug(1323667)}}</li>
</ul>
</div>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Demos_of_open_web_technologies#CSS">CSS demos</a>: Get a creative boost by exploring examples of the latest CSS technologies in action.</li>
 <li>Web languages to which CSS is often applied: <a href="/en-US/docs/Web/HTML">HTML</a>, <a href="/en-US/docs/Web/SVG">SVG</a>, <a href="/en-US/docs/Web/MathML">MathML</a>, {{Glossary("XHTML")}}, and <a href="/en-US/docs/XML_introduction">XML</a>.</li>
 <li>Mozilla technologies that make extensive use of CSS: <a href="/en-US/docs/Mozilla/Firefox">Firefox</a>, and <a href="/en-US/docs/Mozilla/Thunderbird">Thunderbird</a> <a href="/en-US/docs/Mozilla/Add-ons">extensions</a> and <a href="/en-US/docs/Mozilla/Add-ons/Themes">themes</a>.</li>
 <li><a href="https://lists.mozilla.org/listinfo/dev-tech-layout">Mozilla mailing list</a></li>
 <li><a href="https://stackoverflow.com/questions/tagged/css">Stack Overflow questions about CSS</a></li>
</ul>
